import java.io.*;
import java.util.Date;
import java.util.TimeZone;

public class L5App3 {

	public static void main(String[] args) {
		// this code eg demonstrates the class TimeZone, that has several useful
		// static methods.

		// we want to see that the Date object, created with a msec value of 0,
		// actually does correspond to Jan 1, 1970 (as the textbook says it
		// does). But this date is UTC! If we don't change our timezone from the
		// default

		PrintStream output = System.out;
		output.println("The current timezone: " + TimeZone.getDefault());
		// now we change the default time zone. The method for doing this wants
		// as a parameter the timezone obj that encapsulates the desired
		// timezone (not a string that is the abbreviation for the timezone). We
		// can get this timezone object by using another static
		// method "getTimeZone(String)" - we give the method a string, and it
		// gives us a reference to an object
		TimeZone utcTZ = TimeZone.getTimeZone("UTC");
		TimeZone.setDefault(utcTZ);
		output.println("The current timezone after the change is: "
				+ TimeZone.getDefault());
		// note the difference here:
		output.println("here is another format: "
				+ TimeZone.getDefault().getDisplayName());

		Date d;
		d = new Date(); // this is the default, it takes as the value the number
						// of msec since unix epoch at the very instant of
						// invocation (during run-time, not compile-time)
		output.println(d.getTime());
		output.println(d.toString());
		// here we create another Date object
		Date startOfEpoch = new Date(0L);
		// see that it does indeed correspond to the start of unix epoch
		output.println(startOfEpoch.toString());

		// let's try a negative value
		Date dateBeforeStartOfEpoch = new Date(-8778912765860L);
		output.println(dateBeforeStartOfEpoch.toString());
		// yes, we are in the middle ages now!

	}

}
